# edlib.pl - Text Editor subroutines
# This file is part of WebRSH 1.0.1b (beta) Copyright (C) 1997-1998 Yoram Last

sub DoEditCom { # Handles Text Editor commands.

  local($filename,$edcom) = @_;
  unless ($filename) {$filename = $input{'fname'};};
  unless ($edcom) {$edcom = $input{'edcom'};};
  local($tefname,$ofname,$overwrite,$rflag)  = 
    ($input{'tfname'},$input{'ofname'},$input{'overwrite'},$input{'rflag'});
  $edcom =~ s/\s//g;
  $EdFile = $input{'edfile'};
  if ($EdEmptyLnHldr) {
    $EdFile =~ s/^$EdEmptyLnHldr([\r\n])/$1/;
    if (!$EdOPFL) {
      $EdFile =~ s/\n$EdEmptyLnHldr([\r\n])/\n$1/g;
      $EdFile =~ s/\n$EdEmptyLnHldr([\r\n])/\n$1/g;
      $EdFile =~ s/\n$EdEmptyLnHldr$/\n/;
    };
  };
  if ($EdTAMod) {
    $EdFile =~ s/\<$EdTAMod(\/textarea\>)/\<$1/gi;
  };
  $EdFile =~ s/\r\n/\n/g;
  if ($edcom eq 'Save') {
    $tefname = &SaveEdFile($filename);
    if ($tefname) {
      &PromptEFName('Save As...',$tefname,$filename,$filename,$overwrite,1);
    } else {
      &GetEdFile($filename);
      $EdFileName = $filename;
      $PrintEd = 'e';
      $output = "The file $filename had been saved";
    };
  } elsif ($edcom =~ m/^SaveAs/) {
    if ($tefname) {
      $tefname = &RenameTEF($tefname,$filename,$ofname,$overwrite,$rflag);
      unless ($tefname) {
        if ($rflag) {
          &GetEdFile($filename);
          $EdFileName = $filename;
          $PrintEd = 'e';
        };
        $output = "The file $filename had been saved";
      };
    } else {
      $tefname = &SaveEdFile;
      &PromptEFName('Save As...',$tefname,$filename,$filename,$overwrite,1);
    };
  } elsif ($edcom eq 'Save+Exit') {
    $tefname = &SaveEdFile($filename);
    if ($tefname) {
      &PromptEFName('Save As...',$tefname,$filename,$filename,$overwrite,0);
    } else {
      $output = "The file $filename had been saved";
    };
  } elsif ($edcom eq 'Reload' || (!$edcom && !$tefname)) {
    &GetEdFile($filename);
    $EdFileName = $filename;
    $PrintEd = 'e';
  } elsif ($edcom eq 'Options') {
    $EdFileName = $filename;
    $PrintEd = &DoEdOptionCom($input{'opcom'});
  } elsif ($edcom eq 'Exit') {
    $output = "Exited Text Editor without saving";
  } elsif ($edcom eq 'Cancel') {
    if (-e $tefname) {
      &GetEdFile($tefname);
      $EdFileName = $ofname;
      $PrintEd = 'e';
      unless (unlink($tefname)) {
        $output = "Can\'t delete the temporary file $tefname";
      };
    } else {
      $output = "The temporary file $tefname no longer exists";
    };
  } else {
    &WebrshDie("Unknown editor command\: $edcom");
  };
  unless ($output || $!) {$output = 'ok';};
}

sub SaveEdFile { # Saves $EdFile to a file.

  local($filename) = @_;
  local($tefname) = '';
  unless ($filename) {
    $tefname = join('',$TempDir,"\\",$counter,time,'.txt');
    $filename = $tefname;
  };
  open(FILE,">$filename") || &WebrshDie("Error: can\'t save $filename\: $!"); # binmode(FILE);
  print FILE $EdFile;
  close(FILE);
  return $tefname;
}
  
sub GetEdFile { # Reads a text file into $EdFile.

  local($filename) = @_;
  local($buf) = '';
  $EdFile = '';
  if ($filename) {
    open(FILE,"<$filename") || &WebrshDie("Error: can\'t find $filename\: $!"); # binmode(FILE);
    while (read(FILE,$buf,$BufSize)) {
      $EdFile = join('',$EdFile,$buf);
    };
    close FILE;
  };
}

sub RenameTEF { # Renames a temporary file.

  local($tefname,$filename,$ofname,$overwrite,$rflag) = @_;
  unless (-e $tefname) {&WebrshDie("Error: can\'t find $tefname");};  
  if ($filename) {
    local($savename) = $filename;
    unless ($savename =~ m/\w\:/) {$savename = "$pwd\\$savename";};
    local($FileExists) = &ExistFile($filename);
    unless ($FileExists && -d $filename) {
      unless ($FileExists && !$overwrite) {
        if (rename($tefname,$savename)) {
          $tefname = '';
        } else {&PromptEFName('Bad Filename',$tefname,$filename,$ofname,$overwrite,$rflag);};
      } else {&PromptEFName('File Already Exists',$tefname,$filename,$ofname,$overwrite,$rflag);};
    } else {&PromptEFName("$filename is an Existing Directory",$tefname,$filename,$ofname,$overwrite,$rflag);};
  } else {&PromptEFName('No Filename',$tefname,$filename,$ofname,$overwrite,$rflag);};
  return $tefname;
}

sub PromptEFName { # Prompts for a file name in case it is absent or problematic.

  local($problem,$tefname,$filename,$ofname,$overwrite,$rflag) = @_;
  print "Content-type: text/html\n\n";
  print '<HTML><HEAD><TITLE> WebRSH - Text Editor - Name Prompt </TITLE></HEAD>',"\n",
  ' <BODY bgcolor="',"$BGColor",'"><H2> WebRSH: Text Editor: ',"$problem",' </H2>',"\n";
  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  print '<H4> Please choose one of the following: </H4><BR><CENTER>',"\n",
  ' <FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'">',"\n",
  ' <INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
  ' <INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
  ' <INPUT TYPE=hidden name="com" value="rshedit">',"\n",
  ' <INPUT TYPE=hidden name="ofname" value="',"$ofname",'">',"\n",
  ' <INPUT TYPE=hidden name="rflag" value="',"$rflag",'">',"\n",
  ' <INPUT TYPE=hidden name="tfname" value="',"$tefname",'">',"\n",
  ' <INPUT TYPE=checkbox name="overwrite" value="1"';
  if ($overwrite) {print ' CHECKED';};
  print "\>\n",' Overwrite existing file <BR><BR>',"\n",
  ' <INPUT TYPE=submit name="edcom" value="Save As:">',"\n",
  ' <INPUT SIZE="56" name="fname" value="',"$filename",'"><BR><BR>',"\n",
  ' <INPUT TYPE=submit name="edcom" value="              Cancel               ">',"\n",
  ' </FORM><BR><BR><HR></CENTER></BODY></HTML>',"\n";
  $done = 1;
}

sub DoEdOptionCom { # Handles Text Editor options.

  local($opcom) = @_;
  $opcom =~ s/\s//g;
  if ($opcom eq 'OK') {
    require "$ProgDir\\lib\\oplib.pl";
    &ModOptions($0,'editor');
    &GetEdFile($filename);
    return 'e';
  } elsif ($opcom eq 'Apply') {
    require "$ProgDir\\lib\\oplib.pl";
    &ModOptions($0,'editor');
    return 'o';
  } elsif ($opcom eq 'Cancel') {
    &GetEdFile($filename);
    return 'e';
  } elsif ($opcom eq 'Help') {
    $output = 'Help is not yet implemented';
    return '';
  } elsif (!$opcom) {
    return 'o';
  } else {
    &WebrshDie("Unknown command\: $opcom");
  };
}

sub PrintEdit { # Prints Editor output.

  if ($PrintEd eq 'e') {
    &PrintEdFile($EdFileName);
  } elsif ($PrintEd eq 'o') {
    &PrintEdOptions($EdFileName);
  } else {
    &PrintCom;
  };
}

sub PrintEdFile { # Prints Text Editor interface.

  local($filename) = @_;
  print '<HTML><HEAD><TITLE> WebRSH - Text Editor </TITLE></HEAD>',"\n",
  '<BODY bgcolor="',"$BGColor",'"><B> WebRSH: Text Editor: ',"$filename",' </B>',"\n";
  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  unless ($output) {
    print '<H4> Your command did not generate any output </H4>',"\n";
  } else {
    if ($output ne 'ok') {print ' <HR><PRE>',&HtmlText($output),'</PRE>',"\n";};
    if ($EdEmptyLnHldr) {
      $EdFile =~ s/^([\r\n])/$EdEmptyLnHldr$1/;
      if (!$EdOPFL) {
        $EdFile =~ s/\n([\r\n])/\n$EdEmptyLnHldr$1/g;
        $EdFile =~ s/\n([\r\n])/\n$EdEmptyLnHldr$1/g;
        $EdFile =~ s/\n$/\n$EdEmptyLnHldr/;
      };
    };
    if ($EdHtmlText) {
      $EdFile = &HtmlText($EdFile);
    } elsif ($EdTAMod) {
      $EdFile =~ s/\<(\/textarea\>)/\<$EdTAMod$1/gi;
    };
    print '<HR><CENTER>',"\n",
    '<FORM METHOD="POST" ACTION="',"$ScriptUrl",'">',"\n",
    '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
    '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
    '<INPUT TYPE=hidden name="com" value="rshedit">',"\n",
    '<INPUT TYPE=hidden name="fname" value="',"$filename",'">',"\n",
    '<TEXTAREA name="edfile" cols=',"$EdCols",' rows=',"$EdRows";
    if ($EdWrap) {print " wrap\=$EdWrap";};
    print '>',"$EdFile",'</TEXTAREA>',"\n",
    '<BR><BR>',"\n",
    '<INPUT TYPE=submit name="edcom" value="   Save   ">',"\n",
    '<INPUT TYPE=submit name="edcom" value=" Save As  ">',"\n",
    '<INPUT TYPE=submit name="edcom" value="Save+Exit ">',"\n",
    '<INPUT TYPE=reset value="  Reset   "></FORM>',"\n",
    '<FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'">',"\n",
    '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
    '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
    '<INPUT TYPE=hidden name="com" value="rshedit">',"\n",
    '<INPUT TYPE=hidden name="fname" value="',"$filename",'">',"\n",
    '<INPUT TYPE=submit name="edcom" value="  Reload  ">',"\n",
    '<INPUT TYPE=submit name="edcom" value=" Options  ">',"\n",
    '<INPUT TYPE=submit name="edcom" value="   Exit   ">',"\n",
    '</FORM></CENTER>',"\n";
  };
}

sub PrintEdOptions { # Prints the text editor options menu.

  local($filename) = @_;
  print '<HTML><HEAD><TITLE> WebRSH - Text Editor Options</TITLE></HEAD>',"\n",
  '<BODY bgcolor="',"$BGColor",'"><B> WebRSH: Text Editor Options: </B>',"\n";
  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  unless ($output) {
    print '<H4> Your command did not generate any output </H4>',"\n";
  } else {
    if ($output ne 'ok') {print ' <HR><PRE>',&HtmlText($output),'</PRE>',"\n";};
    print ' <HR><FORM METHOD="',"ReqMeth",'" ACTION="',"$ScriptUrl",'">',"\n",
    '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
    '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
    '<INPUT TYPE=hidden name="com" value="rshedit">',"\n",
    '<INPUT TYPE=hidden name="fname" value="',"$filename",'">',"\n",
    '<INPUT TYPE=hidden name="edcom" value="Options">',"\n",
    '<TABLE><TR><TD NOWRAP><B> Window Size: </B></TD><TD NOWRAP COLSPAN=6></TD>',"\n",
    '<TD NOWRAP> Horizontal (columns): ',"\n",
    '<INPUT name="edcols" size="4" value="',"$EdCols",'"></TD>',"\n",
    '<TD NOWRAP COLSPAN=12></TD>',"\n",
    '<TD NOWRAP> Vertical (rows): ',"\n",
    '<INPUT name="edrows" size="4" value="',"$EdRows",'"></TD></TR></TABLE><BR>',"\n",
    '<TABLE><TR><TD NOWRAP><B> Line Wrapping: </B></TD><TD NOWRAP COLSPAN=6></TD>',"\n",
    '<TD NOWRAP><INPUT TYPE=radio name="edwrap" value=""';
    unless ($EdWrap =~ m/virtual/i || $EdWrap =~ m/physical/i) {print ' CHECKED';};
    print '>None </TD><TD NOWRAP COLSPAN=2></TD>',"\n",
    '<TD NOWRAP><INPUT TYPE=radio name="edwrap" value="virtual"';
    if ($EdWrap =~ m/virtual/i) {print ' CHECKED';};
    print '>Virtual </TD><TD NOWRAP COLSPAN=2></TD>',"\n",
    '<TD NOWRAP><INPUT TYPE=radio name="edwrap" value="physical"';
    if ($EdWrap =~ m/physical/i) {print ' CHECKED';};
    print '>Physical </TD></TR></TABLE><BR>',"\n",
    'Note: The line wrapping selection only effects browsers that support this option',"\n",
    '(mainly, Netscape Navigator). The "Virtual" option wraps lines in the display, but',"\n",
    'does not actually insert new lines in the file. The "Physical" option wraps lines',"\n",
    'in the display, and inserts new lines at the wrap points, just as if new-lines',"\n",
    'had been entered. <BR><BR><BR><TABLE><TR>',"\n",
    '<TD NOWRAP><B> Place Holder for Empty Lines: </B></TD><TD NOWRAP COLSPAN=6></TD>',"\n",
    '<TD NOWRAP><INPUT name="lnhldr" value="',"\'$EdEmptyLnHldr\'",'"></TD>',"\n",
    '</TR></TABLE><BR>',"\n",
    'Note: The above place holder can be almost any string of viewable characters',"\n",
    'enclosed in single quotes. (It cannot include any single quotes or consist only of',"\n",
    '0 characters.) This string will be added to empty lines when files are opened with',"\n",
    'the Text Editor. It will be removed when the Text Editor saves a file--if it is the',"\n",
    'only content of a line. This mechanism is used to preserve empty lines, since some',"\n",
    'browsers (notably Lynx) tend to strip them. In most cases, a single white space',"\n",
    'should make a good place holder.',"\n",
    '<BR><BR><BR>',"\n",
    '<TABLE><TR><TD NOWRAP><B> Empty Line Protection Mode: </B></TD><TD NOWRAP COLSPAN=6></TD>',"\n",
    '<TD NOWRAP><INPUT TYPE=checkbox name="opfl" value="1"';
    if ($EdOPFL) {print ' CHECKED';}; 
    print '> Only Protect First Line </TD></TR></TABLE><BR>',"\n",
    '<TABLE><TR><TD NOWRAP><B> Text Formatting: </B></TD><TD NOWRAP COLSPAN=6></TD>',"\n",
    '<TD NOWRAP><INPUT TYPE=checkbox name="htmtxt" value="1"';
    if ($EdHtmlText) {print ' CHECKED';}; 
    print '> Encode Special Characters </TD></TR></TABLE><BR>',"\n",
    '<TABLE><TR><TD NOWRAP><B> &lt/TEXTAREA&gt Modifier: </B></TD><TD NOWRAP COLSPAN=6></TD>',"\n",
    '<TD NOWRAP><INPUT name="tamod" value="',"\'$EdTAMod\'",'"></TD>',"\n",
    '</TR></TABLE><BR>',"\n",
    'Note: The above modifier can be almost any string of viewable characters',"\n",
    'enclosed in single quotes. (It cannot include any single quotes or consist only of',"\n",
    '0 or &lt characters.) This string will be added to follow the first &lt in any',"\n",
    '&lt/TEXTAREA&gt tag when files are opened with the Text Editor. It will be removed',"\n",
    'from such tags when the Text Editor saves a file. This mechanism enables editing',"\n",
    'of HTML files containing &lt/TEXTAREA&gt tags. <BR><BR><BR>',"\n",
    '<CENTER><TABLE><TR><TD>',"\n",
    '<INPUT TYPE=submit name="opcom" value="    OK    "></TD>',"\n",
    '<TD NOWRAP COLSPAN=2></TD><TD>',"\n",
    '<INPUT TYPE=submit name="opcom" value="  Cancel  "></TD>',"\n",
    '<TD NOWRAP COLSPAN=2></TD><TD>',"\n",
    '<INPUT TYPE=submit name="opcom" value="  Apply   "></TD>',"\n",
    '<TD NOWRAP COLSPAN=2></TD><TD>',"\n",
    '<INPUT TYPE=reset value="  Reset   "></TD>',"\n",
    '<TD NOWRAP COLSPAN=2></TD><TD>',"\n",
    '<INPUT TYPE=submit name="opcom" value="   Help   "></TD>',"\n",
    '</TR></TABLE></CENTER></FORM>',"\n";    
  };
}

1; # return true
