# fmlib.pl - File Manager subroutines
# This file is part of WebRSH 1.0.1b (beta) Copyright (C) 1997-1998 Yoram Last

sub DoFMCom { # Handles file-manager commands

  local($fmcom,$file,$clnch,$cdel,$csav,$pcntr,$newname,$overwrite,$clpcln) = 
    ($input{'fmcom'},$input{'file'},$input{'clnch'},$input{'cdel'},$input{'csav'},
      $input{'pcntr'},$input{'newname'},$input{'overwrite'},$input{'clpcln'});
  $fmcom =~ s/\s//g;
  if ($fmcom eq 'Edit')  {
    require "$ProgDir\\lib\\edlib.pl";
    &DoEditCom($file,'');
  } elsif ($fmcom eq 'Properties') {
    $fmProps = 1;
  } elsif ($fmcom eq 'Apply' && $input{'props'}) {
    $fmProps = 1;
    $output = &SetAttributes($file,$input{'atA'},$input{'atS'},$input{'atH'},$input{'atR'});
  } elsif ($fmcom eq 'OK' && $input{'props'}) {
    $output = &SetAttributes($file,$input{'atA'},$input{'atS'},$input{'atH'},$input{'atR'});
  } elsif ($fmcom eq 'New') {
    if ($input{'cnew'}) {
      unless ($pcntr == $counter - 1) {&WebrshDie("This form had expired\!");};
      if (&ExistFile($newname)) {
        &PromptNew(1,$input{'nftype'},$newname);
      } else {
        if ($input{'nftype'} eq 'File') {
          if (open(FILE, ">$newname")) {
            close(FILE);
            $output = "The file $newname had been created.";
          } else {$output = "Can\'t create $newname";};
        } else {
          $output = &ExSysCom("mkdir \"$newname\"");
          unless (!-e $newname || $! || $output) {
            $output = "The directory $newname had been created.";
          };
        };
      };
    } else {
      unless ($pcntr) {&PromptNew(0,'Directory',&FullPath($pwd,'New'));};
    };
  } elsif ($input{'fmcancel'} && $clpcln) {
    $clip = '';
  } elsif ($file) {
    if (-d $file) {$ftype = 'directory';} else {$ftype = 'file';};
    if ($fmcom eq 'Open') {
      if ($ftype eq 'directory') {
        &ChangeDir($file); 
        unless ($!) {$output = 'ok';};
      } else {
        if ($clnch) {
          unless ($pcntr == $counter - 1) {&WebrshDie("This form had expired\!");};
          &RshStart($file);
          unless ($!) {$output = join(' ','The file',&FullPath($pwd,$file),'had been launched!');};
        } else {
          unless ($pcntr) {&PromptLaunch($file);};
        };
      };
    } elsif ($file ne '..') {
      if ($fmcom eq 'Delete') {
        if ($cdel) {
          unless ($pcntr == $counter - 1) {&WebrshDie("This form had expired\!");};
          $output = &DelFile(&FullPath($pwd,$file));
          unless ($output || $!) {
            if (&ExistFile(&FullPath($pwd,$file))) {
              $output = join('',"WebRSH encountered a problem when attempting to delete the ",
                "$ftype $file.\nPlease check the current state of $file.");
            } else {
              $output = "The $ftype $file had been deleted\!";
            };
          };
        } else {
          unless ($pcntr) {&PromptDel($file,$ftype);};
        };
      } elsif ($fmcom eq 'Rename') {
        if ($csav) {
          unless ($pcntr == $counter - 1) {&WebrshDie("This form had expired\!");};
          if (&RenameFile($file,$newname,$overwrite,$clpcln) && -e $newname && !$!) {
            $output = "The $ftype $file had been renamed to:\n $newname";
          };
        } else {
          unless ($pcntr) {&PromptSav('Rename',$file,$ftype,&FullPath($pwd,$file));};
       };
      } elsif ($fmcom eq 'FCopy') {
        if ($csav) {
          unless ($pcntr == $counter - 1) {&WebrshDie("This form had expired\!");};
          $output = &CopyFile($file,$newname,$overwrite,$clpcln);
        } else {
          unless ($pcntr) {&PromptSav('FCopy',$file,$ftype,&FullPath($pwd,$file));};
       };
      } elsif ($fmcom eq 'Cut') {
        $clip = join(' ','Cut',&FullPath($pwd,$file));
      } elsif ($fmcom eq 'Copy') {
        $clip = join(' ','Copy',&FullPath($pwd,$file));
      } elsif ($fmcom eq 'GET')  {
        &SendFile($file);
        $done = 1;
      } elsif ($fmcom eq 'GETasTEXT') {
        &SendTextFile($file);
        $done = 1;
      } elsif ($fmcom eq 'GETasBIN') {
        &SendBinFile($file);
        $done = 1;
      };
    }; 
  } elsif ($fmcom eq 'Paste') {
    if ($clip) {
      local($clcom,$clfile) = split(' ',$clip,2);
      unless (-e $clfile) {&WebrshDie("Can\'t find $clfile: $!");};
      if (-d $clfile) {$ftype = 'directory';} else {$ftype = 'file';};
      unless ($newname) { 
        $newname = &FileName($clfile);
        if ($newname) {$newname = &FullPath($pwd,$newname);};
      };
      if ($newname && $clcom eq 'Cut') {
        if (&RenameFile($clfile,$newname,$overwrite,'1') && -e $newname && !$!) {
          $output = "The $ftype $clfile had been renamed to:\n $newname";
        };
      } elsif ($newname && $clcom eq 'Copy') {
        $output = &CopyFile($clfile,$newname,$overwrite,'1');
      };
    };
  };
  unless ($output || $!) {$output = 'ok';};
}

sub PromptNew { # Prompts to create a new file or directory.

  local($fexist,$nftype,$newname) = @_;
  print "Content-type: text/html\n\n";
  print '<HTML><HEAD><TITLE> WebRSH - New </TITLE></HEAD>',"\n",
  ' <BODY bgcolor="',"$BGColor",'"><H2> WebRSH: New: ';
  if ($fexist) {print 'File Already Exists ';};
  print '</H2>',"\n";
  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  unless ($fexist) {
    print '<H4> Please choose the type of the new object you wish to create, ',"\n",
    ' and enter a name for it. </H4><BR><CENTER>',"\n";
  } else {
     print '<H4> Please enter another name for the new object you wish to create.',"\n",
     ' </H4><BR><CENTER>',"\n";
  };
  print '<FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'">',"\n",
  '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
  '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
  '<INPUT TYPE=hidden name="com" value="rshfm">',"\n",
  '<INPUT TYPE=hidden name="fmcom" value="New">',"\n",
  '<INPUT TYPE=hidden name="pcntr" value="',"$counter",'">',"\n";
  if ($nftype eq 'File') {
    print '<TABLE><TR><TD COLSPAN=44>',"\n",
    '<INPUT TYPE=radio name="nftype" value="Directory"> Directory </TD><TD>',"\n",
    '<INPUT TYPE=radio name="nftype" value="File" CHECKED> File </TD></TR></TABLE><BR>',"\n";
  } else {
    print ' <TABLE><TR><TD COLSPAN=44>',"\n",
    '<INPUT TYPE=radio name="nftype" value="Directory" CHECKED> Directory </TD>',"\n",
    '<TD><INPUT TYPE=radio name="nftype" value="File"> File </TD></TR></TABLE><BR>',"\n";
  };
  print '<INPUT TYPE=submit name="cnew" value="   Create:   ">',"\n",
  '<INPUT SIZE="56" name="newname" value="',"$newname",'"><BR><BR>',"\n",
  '<INPUT TYPE=submit VALUE="            Cancel            "></FORM><BR>',"\n",
  '<HR></CENTER></BODY></HTML>',"\n";
  $done = 1;
}

sub PromptLaunch { # Prompts to confirm launching a file.

  local($file) = @_;
  print "Content-type: text/html\n\n";
  print '<HTML><HEAD><TITLE> WebRSH - Launch </TITLE></HEAD>',"\n",
  ' <BODY bgcolor="',"$BGColor",'"><H2> WebRSH: Launch: </H2>',"\n";
  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  print '<H4> Are you sure you want to launch the file ',"\'$file\'\n",
  'on ',"$HostName",' ? </H4><BR><CENTER>',"\n",
  '<FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'">',"\n",
  '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
  '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
  '<INPUT TYPE=hidden name="com" value="rshfm">',"\n",
  '<INPUT TYPE=hidden name="fmcom" value="Open">',"\n",
  '<INPUT TYPE=hidden name="pcntr" value="',"$counter",'">',"\n",
  '<INPUT TYPE=hidden name="file" value="',"$file",'">',"\n",
  '<INPUT TYPE=submit name="clnch" value="            Launch            "><BR><BR>',"\n",
  '<INPUT TYPE=submit VALUE="            Cancel            "></FORM><BR>',"\n",
  '<HR></CENTER></BODY></HTML>',"\n";
  $done = 1;
}

sub PromptDel { # Prompts to confirm deleting a file or a directory.

  local($file,$ftype) = @_;
  print "Content-type: text/html\n\n";
  print '<HTML><HEAD><TITLE> WebRSH - Delete </TITLE></HEAD>',"\n",
  ' <BODY bgcolor="',"$BGColor",'"><H2> WebRSH: Delete: </H2>',"\n";
  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  print '<H4> Are you sure you want to delete the ',"$ftype \'$file\'";
  if ($ftype eq 'directory') {print ' and all the files in it';};
  print ' ? </H4><BR><CENTER>',"\n",
  '<FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'">',"\n",
  '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
  '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
  '<INPUT TYPE=hidden name="com" value="rshfm">',"\n",
  '<INPUT TYPE=hidden name="fmcom" value="Delete">',"\n",
  '<INPUT TYPE=hidden name="pcntr" value="',"$counter",'">',"\n",
  '<INPUT TYPE=hidden name="file" value="',"$file",'">',"\n",
  '<INPUT TYPE=submit name="cdel" value="            Delete            "><BR><BR>',"\n",
  '<INPUT TYPE=submit VALUE="            Cancel            "></FORM><BR>',"\n",
  '<HR></CENTER></BODY></HTML>',"\n";
  $done = 1;
}

sub PromptSav { # Prompts to copy or rename a file or a directory.

  local($fmcom,$file,$ftype,$newname) = @_;
  local($dfmcom) = $fmcom;
  if ($fmcom eq 'FCopy') {$dfmcom = 'Copy';};
  print "Content-type: text/html\n\n";
  print '<HTML><HEAD><TITLE> WebRSH - ',"$dfmcom",' </TITLE></HEAD>',"\n",
  ' <BODY bgcolor="',"$BGColor",'"><H2> WebRSH: ',"$dfmcom",': </H2>',"\n";
  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  print '<H4> Please enter the new name for the ',"$ftype \'$file\'","\n",
  '</H4><BR><CENTER>',"\n",
  '<FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'">',"\n",
  '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
  '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
  '<INPUT TYPE=hidden name="com" value="rshfm">',"\n",
  '<INPUT TYPE=hidden name="fmcom" value="',"$fmcom",'">',"\n",
  '<INPUT TYPE=hidden name="pcntr" value="',"$counter",'">',"\n",
  '<INPUT TYPE=hidden name="file" value="',"$file",'">',"\n",
  '<INPUT TYPE="checkbox" name="overwrite" value="1"> Overwrite existing files <BR><BR>',"\n",
  '<INPUT TYPE=submit name="csav" value="',"$dfmcom",' to:">',"\n",
  '<INPUT SIZE="56" name="newname" value="',"$newname",'"><BR><BR>',"\n",
  '<INPUT TYPE=submit VALUE="            Cancel            "></FORM><BR>',"\n",
  '<HR></CENTER></BODY></HTML>',"\n";
  $done = 1;
}

sub DelFile { # Deletes a file or a directory.

  local($file) = @_;
  if ($OStype eq 'w95') {
    $_ = &ExSysCom("deltree /y \"$file\"");
  } else {
    if (-d $file) {
      $_ = &ExSysCom("rmdir /S /Q \"$file\"");
    } else {
      &SetAttributes($file,'','','','');
      $_ = &ExSysCom("del /F /Q \"$file\"");
    };
  };
  return $_;
}

sub RenameFile { # Renames a file or a directory.

  local($file,$newname,$overwrite,$clpcln) = @_;
  local($success) = 0;
  unless (-e $file) {&WebrshDie("Can\'t find $file: $!");};  
  if ($newname) {
    local($FileExists) = &ExistFile($newname);
    unless ($FileExists && -d $newname) {
      unless ($FileExists && !$overwrite) {
        if (rename($file,$newname)) {
          $success = 1;
          if ($clpcln) {$clip = '';};
        } else {&SaveProblem('Rename','Bad Filename',$file,$newname,$overwrite,$clpcln);};
      } else {&SaveProblem('Rename','File Already Exists',$file,$newname,$overwrite,$clpcln);};
    } else {&SaveProblem('Rename',"$newname is an Existing Directory",$file,$newname,$overwrite,$clpcln);};
  } else {&SaveProblem('Rename','No Filename',$file,$newname,$overwrite,$clpcln);};
  return $success;
}

sub CopyFile { # Copies a file or a directory.

  local($file,$newname,$overwrite,$clpcln) = @_;
  local($output) = '';
  unless (-e $file) {&WebrshDie("Can\'t find $file: $!");};  
  if ($newname) {
    local($FileExists) = &ExistFile($newname);
    unless ($FileExists && -d $newname) {
      unless ($FileExists && !$overwrite) {
        local($yswitch) = '';
        if ($OStype eq 'w95') {$yswitch = '/Y';};
        if (-d $file) {
          $output = &ExSysCom("xcopy \"$file\" \"$newname\" /E /C /I /H /R /K $yswitch");
        } else {
          if (!$FileExists || ($file ne $newname && unlink($newname))) {
            local($FileName) = &FileName($file);
            local($time) = time;
            local($TempDirName) = join('',&DirName($newname),"\\webrsh-$counter$time\.temp");
            $output = &ExSysCom("xcopy \"$file\" \"$TempDirName\\\" /C /H /R /K $yswitch");
            if (rename("$TempDirName\\$FileName",$newname)) {rmdir($TempDirName);};
          } else {&SaveProblem('FCopy','Bad Filename',$file,$newname,$overwrite,$clpcln);};
        };
        if ($clpcln) {$clip = '';};
      } else {&SaveProblem('FCopy','File Already Exists',$file,$newname,$overwrite,$clpcln);};
    } else {&SaveProblem('FCopy',"$newname is an Existing Directory",$file,$newname,$overwrite,$clpcln);};
  } else {&SaveProblem('FCopy','No Filename',$file,$newname,$overwrite,$clpcln);};
  return $output;
}

sub SaveProblem { # Prompts for corrective action in case RenameFile or CopyFile run into problems.

  local($fmcom,$problem,$file,$newname,$overwrite,$clpcln) = @_;
  local($dfmcom) = $fmcom;
  if ($fmcom eq 'FCopy') {$dfmcom = 'Copy';};
  print "Content-type: text/html\n\n";
  print '<HTML><HEAD><TITLE> WebRSH - File Saving Problem </TITLE></HEAD>',"\n",
  '<BODY bgcolor="',"$BGColor",'"><H2> WebRSH: ',"$dfmcom",' Problem: ',"$problem",' </H2>',"\n";
  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  print '<H4> Please choose one of the following: </H4><BR><CENTER>',"\n",
  '<FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'">',"\n",
  '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
  '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
  '<INPUT TYPE=hidden name="com" value="rshfm">',"\n",
  '<INPUT TYPE=hidden name="file" value="',"$file",'">',"\n",
  '<INPUT TYPE=hidden name="newname" value="',"$newname",'">',"\n",
  '<INPUT TYPE=hidden name="fmcom" value="',"$fmcom",'">',"\n",
  '<INPUT TYPE=hidden name="pcntr" value="',"$counter",'">',"\n",
  '<INPUT TYPE=hidden name="clpcln" value="',"$clpcln",'">',"\n",
  '<INPUT TYPE=hidden name="overwrite" value="1">',"\n";
  if ($problem eq 'File Already Exists') {
    print '<INPUT TYPE=submit name="csav" VALUE="  Overwrite existing file  "><BR><BR>',"\n";
  }; 
  print '<INPUT TYPE=submit VALUE="            Cancel            "></FORM><BR>',"\n", 
  '<FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'">',"\n",
  '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
  '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
  '<INPUT TYPE=hidden name="com" value="rshfm">',"\n",
  '<INPUT TYPE=hidden name="file" value="',"$file",'">',"\n",
  '<INPUT TYPE=hidden name="fmcom" value="',"$fmcom",'">',"\n",
  '<INPUT TYPE=hidden name="pcntr" value="',"$counter",'">',"\n",
  '<INPUT TYPE=hidden name="clpcln" value="',"$clpcln",'">',"\n",
  '<INPUT TYPE=hidden name="overwrite" value="',"$overwrite",'">',"\n",
  '<INPUT TYPE=submit name="csav" VALUE="',"$dfmcom",' to:">',"\n",
  '<INPUT SIZE="56" name="newname" value="',"$newname",'">',"\n",
  '</FORM><BR><HR></CENTER></BODY></HTML>',"\n";
  $done = 1;
}

sub GetAttributes { # Gets the attributes of a file or a directory.

  local($file) = @_;
  local($atA,$atS,$atH,$atR);
  if (!$file || $file eq '.') {
    $file = $pwd;
  } elsif ($file eq '..') {
    $file = $pwd;
    $file =~ s/[^\\^\/]+$//;
    chop($file);
  };
  $_ = &ExSysCom("attrib \"$file\"");
  $_ =~ s/\w\:\\.+\n$//;
  if ($OStype eq 'w95') {$_ =~ s/\S+\s+$//;};
  $_ =~ s/\s//g;
  $atA = $_ =~ m/A/;
  $atS = $_ =~ m/S/;
  $atH = $_ =~ m/H/;
  $atR = $_ =~ m/R/;
  return ($atA,$atS,$atH,$atR);
}

sub SetAttributes { # Sets the attributes of a file or directory.

  local($file,$atA,$atS,$atH,$atR) = @_;
  if (!$file || $file eq '.') {
    $file = $pwd;
  } elsif ($file eq '..') {
    $file = $pwd;
    $file =~ s/[^\\^\/]+$//;
    chop($file);
  };
  if ($atA) {$atA = '+A';} else {$atA = '-A';};
  if ($atS) {$atS = '+S';} else {$atS = '-S';};
  if ($atH) {$atH = '+H';} else {$atH = '-H';};
  if ($atR) {$atR = '+R';} else {$atR = '-R';};
  $_ = &ExSysCom("attrib $atA $atS $atH $atR \"$file\"");
  return $_;
}

sub GetDirInfo { # Gets "dir" information for a file or a directory.

  local($file) = @_;
  $_ = &ExSysCom("dir /A \"$file\"");
  return $_;
}

sub MakeStr { # Duplicates a string to form a longer string.

  local($str,$length) = @_;
  local($i,$outstr) = (0,'');
  foreach $i (1..$length) {
    $outstr = join('',$outstr,$str);
  };
  return $outstr;
}

sub TruncStr { # Truncates a string to fit a specified length if it is too long. Attaches '...'
               # to its end if a truncation occurs.

  local($str,$length) = @_;
  if (length($str) > $length) {
     $str = join('',substr($str,0,$length - 3),'...');
  };
  return $str;
}

sub PrintFM { # Prints File Manager or Text Editor output.

  if ($PrintEd) {
    &PrintEdit;
  } else {
    &PrintFMO;
  };
}

sub PrintFMO { # Prints File Manager output.

  print '<HTML><HEAD><TITLE> WebRSH - File Manager </TITLE></HEAD>',"\n",
  '<BODY bgcolor="',"$BGColor",'"><B> WebRSH: File Manager: </B>',"\n";
  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  unless ($output) {print '<H4> Your command did not generate any output </H4>',"\n";}
  else {
    &GetDirList(1); &GetFileList(1);
#    print ' Choose a file or directory from the list. Then choose the appropriate',"\n",
#    'action by clicking one of the buttons below. Note that "Open", when applied to a file,',"\n",
#    'will LAUNCH it on ',"$HostName\.","\n";
    if ($output ne 'ok') {print ' <HR><PRE>',&HtmlText($output),'</PRE>',"\n";};
    if ($fmProps) {
      local($file) = $input{'file'};
      local($atA,$atS,$atH,$atR) = &GetAttributes($file);
      print ' <HR><B> Properties of: ',"$file\n</B><PRE>",
      &HtmlText(&GetDirInfo($file)),"\n</PRE><P>\n",
      '<FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'">',"\n",
      '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
      '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
      '<INPUT TYPE=hidden name="com" value="rshfm">',"\n",
      '<INPUT TYPE=hidden name="file" value="',"$file",'">',"\n",
      '<INPUT TYPE=hidden name="props" value="1">',"\n",
      '<TABLE><TR><TD COLSPAN=32><B> Attributes: </B></TD><TD COLSPAN=24>',"\n",
      '<INPUT TYPE=checkbox name="atA" value="1"'; if ($atA) {print ' CHECKED';}; 
      print '>Archive </TD><TD COLSPAN=28>',"\n",
      '<INPUT TYPE=checkbox name="atS" value="1"'; if ($atS) {print ' CHECKED';}; 
      print '>System </TD><TD COLSPAN=28>',"\n",
      '<INPUT TYPE=checkbox name="atH" value="1"'; if ($atH) {print ' CHECKED';}; 
      print '>Hidden </TD><TD COLSPAN=28>',"\n",
      '<INPUT TYPE=checkbox name="atR" value="1"'; if ($atR) {print ' CHECKED';}; 
      print '>Read-only </TD></TR></TABLE><BR>',"\n",
      '<INPUT TYPE=submit name="fmcom" VALUE="     OK      ">',"\n",
      '<INPUT TYPE=submit VALUE="    Cancel   ">',"\n",
      '<INPUT TYPE=submit name="fmcom" VALUE="    Apply    "></FORM>',"\n";
    };
    if ($clip) {
      local($clcom, $clfile) = split(' ',$clip,2);
      local($fmcom,$ftype,$newname);
      if (-d $clfile) {$ftype = 'directory';} else {$ftype = 'file';};
      $newname = &FileName($clfile);
      if ($newname) {$newname = &FullPath($pwd,$newname);};
      if ($newname && $clcom eq 'Cut') {$fmcom = 'Rename';}
        elsif ($newname && $clcom eq 'Copy') {$fmcom = 'FCopy';};
      print ' <HR><B> Clipboard content is: ',"$clip",'</B><BR>',"\n",
      '<FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'">',"\n",
      '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
      '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
      '<INPUT TYPE=hidden name="com" value="rshfm">',"\n",
      '<INPUT TYPE=hidden name="fmcom" value="',"$fmcom",'">',"\n",
      '<INPUT TYPE=hidden name="pcntr" value="',"$counter",'">',"\n",
      '<INPUT TYPE=hidden name="file" value="',"$clfile",'">',"\n",
      '<INPUT TYPE=hidden name="clpcln" value="1">',"\n",
#      '<INPUT TYPE="checkbox" name="overwrite" value="1"> Overwrite existing files <BR><BR>',"\n",
      '<INPUT TYPE=submit name="csav" value="Paste as:">',"\n",
      '<INPUT SIZE="56" name="newname" value="',"$newname",'"><BR><BR>',"\n",
      '<INPUT TYPE=submit name="fmcancel" VALUE="            Cancel            "></FORM>',"\n";
    };
    local($JSstr) = '';
    if ($XPath) {
      $JSstr = " onClick=\"fmMain.action = fmMain.action + \'/\' + escape\(fmMain.elements[3].options[fmMain.elements[3].selectedIndex].value\)\"";
    };
    print '<CENTER><HR><B>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshfm&file=..&fmcom=Open">',"\n",
    '<IMG SRC="',"$SendFilesUrl",'/highdir.gif" ALIGN=top HSPACE=0 BORDER=0 ALT="Up"></A>',"\n",
    'Working Directory is: ',"$pwd",' </B>',"\n",
    '<FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'" NAME="fmMain">',"\n",
    '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
    '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
    '<INPUT TYPE=hidden name="com" value="rshfm">',"\n",
    '<SELECT NAME="file" SIZE="',"$FMSize",'">',"\n",
    '<OPTION VALUE=".."> \.. ',"\n";
    foreach $i (0..$#dirarray) {
      print '<OPTION VALUE="',"$dirarray[$i]",'"> ',&TruncStr("\\$dirarray[$i]",$FMHSize),"\n";
    };
    print '<OPTION VALUE=""> ',"\n",&MakeStr('-',$FMHSize),"\n";
    foreach $i (0..$#filearray) {
      print '<OPTION VALUE="',"$filearray[$i]",'"> ',&TruncStr($filearray[$i],$FMHSize),"\n";
    };
    print '</SELECT> <BR><BR>',"\n",
    '<INPUT TYPE=submit name="fmcom" value="  Open  ">',"\n",
    '<INPUT TYPE=submit name="fmcom" value="  Cut   ">',"\n",
    '<INPUT TYPE=submit name="fmcom" value="  Copy  ">',"\n",
    '<INPUT TYPE=submit name="fmcom" value=" Paste  ">',"\n",
    '<INPUT TYPE=submit name="fmcom" value=" Delete ">',"\n",
    '<INPUT TYPE=submit name="fmcom" value=" Rename ">',"\n",
    '<INPUT TYPE=submit name="fmcom" value="  New   "> <BR><BR>',"\n",
    '<INPUT TYPE=submit name="fmcom" value="   Edit    ">',"\n",
    '<INPUT TYPE=submit name="fmcom" value="    GET    "',"$JSstr>\n",
    '<INPUT TYPE=submit name="fmcom" value="GET as BIN "',"$JSstr>\n",
    '<INPUT TYPE=submit name="fmcom" value="GET as TEXT"',"$JSstr>\n",
    '<INPUT TYPE=submit name="fmcom" value="Properties "></FORM></CENTER>',"\n";
  }
}

1; # return true