# rkpslib.pl - Process handling subroutines
# This file is part of WebRSH 1.0.1b (beta) Copyright (C) 1997-1998 Yoram Last

sub RshPs { # Returns a list of currently running processes.

  return &ExSysCom("tlist");
}

sub RshKill { # Terminates a process.

  local($pid) = @_;
  return &ExSysCom("kill $pid");
}

sub GetKillList { # Creates three equal-length arrays (@kname,@kpid,@lkill) containing names,
                  # PIDs, and url-encoded kill commands for currently running processes.

  local($pid,$name,$wname);
  $killlist = &ExSysCom("tlist");
  $killlist =~ s/^\s*\-2\sIdle\.exe\s*\n//;
  $killlist =~ s/^\s*0\sSystem\sProcess\s*\n//;
  $killlist =~ s/\s*\-2\s\_Total\.exe\s*\n$//;
  $killlist =~ s/\n$//;
  @killarray = split(/\n/,$killlist);
  foreach $i (0..$#killarray) {
    $killarray[$i] =~ s/^\s*//;
    ($pid,$name,$wname) = split(/\s+/,$killarray[$i],3);
    $kpid[$i] = $pid;
    $lkill[$i] = "rshkill $kpid[$i]";
    $lkill[$i] = &UrlEncode($lkill[$i]);
    $kname[$i] = $name;
  }
}

sub PrintKill { # Prints the list of "Killable Links."

print '<HTML><HEAD><TITLE> WebRSH - Killable links </TITLE></HEAD>',"\n",
  '<BODY bgcolor="',"$BGColor",'"><B> WebRSH: Killable Links: </B>',"\n";
  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  unless ($output) {print '<P> Your command did not generate any output </P>',"\n";}
  else {
    print '<P> The list below contains links to processes currently running on ',"\n",
    "$HostName",'. Clicking any of these links will TERMINATE (kill) the corresponding process.',"\n",
    '</P><CENTER><HR></CENTER><TABLE>',"\n";
    foreach $i (0..$#kpid) {
      print '<TR><TD NOWRAP><B>',"\n",
      '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=',"$lkill[$i]",'">',"\n",
      '<IMG SRC="',"$SendFilesUrl",'/redball.gif" HSPACE=4 BORDER=0> ! KILL:  ',"$kname[$i]",'</A>',"\n",
      ' [ pid = ',"$kpid[$i]",' ] </B></TD></TR>',"\n";
    }
  }
  print '<TR><TD></TD></TR></TABLE>',"\n";
}

1; # return true