#! */perl
#
# WebRSH 1.0.1b (beta) A Remote-Computing CGI Script for Windows 95/NT.
# Copyright (C) 1997-1998  Yoram Last
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# The author of this program can be contacted by e-mail at ylast@mindless.com.
# Please see the accompanying documentation for usage instructions.
#
# WARNING: This program has an above-average potential for causing damage!
# In particular, it may allow unauthorized remote access to your computer and to
# network resources available to your computer. It may also cause your computer
# to "crash" while you are away from it and thus unable to restart it. It is
# recommended that you avoid using this program unless "you know what you are doing."
# You should avoid placing this program in any publicly accessible CGI-enabled
# directory on your system.

$VerInf = join('','<SMALL>WebRSH 1.0.1b (beta) by ',"\n",
      '<B><I><A HREF="mailto:Yoram Last &lt;ylast@mindless.com&gt;">ylast</A></I></B></SMALL>');

#-!-!-!> DO NOT MODIFY THIS LINE, AND DO NOT ADD A '#-!-!-!>' ANYWHERE ELSE IN THIS SCRIPT!
#################################################################################################
# The following variables can be configured through WebRSH's 'Options' menu item. It is         #
# recommended that you DO NOT make any manual modifications to this part of the script.         #
#################################################################################################

$ProgDir = 'C:\WebRSH';
# DOS path to WebRSH's main directory.

$SendFilesDir = "$ProgDir\\sfdir";
# The path to a directory that can be accessed through the server, and is used to place icons.

$SendFilesUrl = '/sfdir';
# URL of $SendFilesDir (The path by which it is recognized by the server).

$HomeDir = "$ProgDir\\home";
# The default working directory for WebRSH.

$CfgDir = "$ProgDir\\cfg";
# A directory in which configuration files are stored.

$TempDir = "$ProgDir\\temp";
# A directory to which temporary files are written.

$LocSecurity = 1;
# Setting it to 1 enables location based access restriction. Setting it to 0 disables it.

@AllowAddr = ('127\.0\.0\.1');
# ('a','coma','separated','list','of','IP','patterns','in','qoutes')
# from which access to WebRSH is allowed.

@DenyAddr = ();
# Similarly, a list of patterns from which to deny access.

$CheckForAuth = 0;
# If set to 1, the script will varify that some access authentication took place by checking for
# the existence of the environment variable 'AUTH_TYPE'. Setting it to 0 disables this check.

$CheckForUser = 0;
# If set to 1, only users that appear in the @AllowUsers array will be allowed access to WebRSH.
# If set to 0, all users (that have been allowed access by the server) will be allowed.

@AllowUsers = ();
# ('a','coma','separated','list','of','user names','in','qoutes') for which access to WebRSH
# will be allowed.

$MakeBack = 1;
# If set to 1, a backup copy of the main script will be saved whenever options are changed.
# This backup copy will have the same name as the main script except for a '-' added just
# before the extension. If set to 0, no backup will be done.

$BGColor = '#fffbf0';
# The background color used for WebRSH's documents.

$HostName = 'the remote host';
# The name of the computer running WebRSH. This is only used in generating text for some of
# WebRSH's documents.

$GetOptions = 'T';
# Determines the kind of "downloadable links" that will be generated (in addition to the usual
# 'GET' links) as part of the  appropriate directory listings. 'B' will generate 'GET as BIN'
# links. 'T' will generate 'GET as TEXT' links. 'BT' will generate both.

$BinText = 1;
# If set to 0, files sent with the 'GET as TEXT' option will have CR-LF converted to LF, namely,
# they will be converted to "UNIX-format" text files. If set to 1, these files will be sent in
# their exact binary format (which is the same way they will sent with the 'GET' or 'GET as BIN'
# options).

$DefMimeType = 'application/octet-stream';
# Default MIME type to be reported for downloaded files. Only relevant for files with extensions
# that do not appear in Mimetable.txt.

$XPath = 1;
# If set to 1, file names will be added as extra path information whenever files are downloaded
# through one of the 'GET' options. This enables the browser to know the correct filename for
# downloaded files. If set to 0, such extra path information will not be added.

$GCLH = 1;
# If set to 1, the script will supply a 'Content-length' header when a file is dowloaded through
# one of the 'GET' options or when responding to an 'rshtextmode' command. If set to 0, such a
# header will not be provided.

$BufSize = 32768;
# The default size (in bytes) for buffers.

$ReqMeth = 'GET';
# The request method used by most of WebRSH's forms.

$AppendToPI = 1;
# Determines whether or not WebRSH will append its main form to the output of plugins. The
# plugin itself can always modify $AppendToPI to override the default behavior set here.

$PsLib = 'pslib.pl';
# The name of the library file to supply process related subroutines.

$ComFieldSize = 64;
# Size of the command input field in WebRSH's main form.

$FMSize = 14;
# Vertical size of the File Manager select field.

$FMHSize = 64;
# Horizontal size of the File Manager select field.

$EdCols = 72;
# Horizontal width (in columns) of the Text Editor window.

$EdRows = 22;
# Vertical width (in rows) of the Text Editor window.

$EdWrap = '';
# Sets the line wrapping option for the Text Editor window. This is only relevant when used with
# suitable browsers (mainly, with Netscape Navigator). Valid options are 'virtual', 'physical',
# and '' (none).

$EdEmptyLnHldr = ' ';
# Added to empty lines when files are opened with the Text Editor. Removed when the Text Editor
# saves a file--if it is the only content of a line. This is used to preserve empty lines in
# text files, since some browsers (notably Lynx) tend to strip them.

$EdOPFL = 1;
# If set to 1, only the first line of files opened with the Text Editor (if it is empty)
# will be protected with the $EdEmptyLnHldr mechanism. If set to 0 and $EdEmptyLnHldr is not
# null, all empty lines will be protected.

$EdHtmlText = 1;
# If set to 1, files opened with the Text Editor will be converted to HTML-formatted text using
# the HtmlText subroutine. If set to 0, such conversion will not take place. An appropriate
# setting here is very important (in particular, to enable editing of HTML files), and depends
# on the browser: Netscape Navigator, Microsoft Internet Explorer, and Lynx require the setting
# to be 1. Other browsers (e.g., NCSA Mosaic 3.0) may require it to be 0.

$EdTAMod = '/';
# This will be added to follow the first '<' in any </TEXTAREA> tag when files are opened with
# the Text Editor. It will be removed from such tags when the Text Editor saves a file. This
# mechanism enables editing of HTML files containing </TEXTAREA> tags with browsers that require
# $EdHtmlText to be set to 0.

#-!-!-!> DO NOT MODIFY THIS LINE, AND DO NOT ADD A '#-!-!-!>' ANYWHERE ELSE IN THIS SCRIPT!
#################################################################################################
# The following variables can be optionally configured. Do not change them without reason.      #
#################################################################################################

$OStype = '';
# The operating system in use (either 'w95' or 'wNT'). If left null, the script should find it
# out by itself.

$ScriptUrl = $ENV{'SCRIPT_NAME'};
# URL of this script (The path by which it is recognized by the server).

# $ENV{'COMSPEC'} = 'C:\WINDOWS\COMMAND.COM'; # Enable and modify as needed.

# $ENV{'PATH'} = 'C:\WINDOWS;C:\WINDOWS\COMMAND;'; # Enable and modify as needed.

# $ENV{'TEMP'} = "$TempDir"; # Enable and modify as needed.

# $ENV{'TMP'} = "$TempDir"; # Enable and modify as needed.

#################################################################################################
# The WebRSH program starts from here:                                                          #
#################################################################################################

unless ((!$LocSecurity || &AllowAddr($ENV{'REMOTE_ADDR'})) &&
        (!$CheckForAuth || $ENV{'AUTH_TYPE'}) && 
        (!$CheckForUser || &ConfirmUser)) {
  &WebrshDie('You are not allowed to access this program!');
};

if ($ENV{'QUERY_STRING'} =~ m/^rshplugin/) { # If a plugin is called, call it.

  if ($ARGV[0] eq 'rshplugin') {
    $ComLineMode = 1;
    shift;
    $rshId = shift;
    $rshPWD = shift;
    $rshPWDpc = shift;
    while ($rshPWDpc && $rshPWDpc ne '::') {
      $rshPWD = join(' ',$rshPWD,$rshPWDpc);
      $rshPWDpc = shift;
    };
    if ($rshPWD =~ m/\\[\\\/]/) {$rshPWD =~ s/\\[^\\]/\\$&/g; $rshPWD =~ s/\\\\//g;};
    $lrshPWD = &UrlEncode($rshPWD);
    $PlugIn = shift;
    unless ($rshId && $lrshPWD) {&WebrshDie("Error\: Bad query")}; 
  } else {
    $ENV{'QUERY_STRING'} =~ m/^(rshplugin\+)(\w.\d+)(\+)(.+)(\+\%3A\%3A\+)(.*)$/ ||
      &WebrshDie("Error\: Bad query");
    ($rshId,$lrshPWD,$PlugIn) = ($2,$4,$6);
  };
  if ($PlugIn) {
    chdir "$ProgDir\\lib" || &WebrshDie("Can\'t change to lib directory: $!");
    ($PlugIn, $PIFirstArg) = split(/\?/,$PlugIn,2);
    if ($ComLineMode && $PIFirstArg) {unshift(@ARGV,$PIFirstArg);};
    $ENV{'SCRIPT_NAME'} = "$ScriptUrl\?rshplugin\+$rshId\+$lrshPWD\+\%3A\%3A\+$PlugIn";
    if ($ENV{'QUERY_STRING'} =~ m/\?/) {
      $ENV{'QUERY_STRING'} =~ s/^.*\?//;
    } else {
      $ENV{'QUERY_STRING'} = '';
    };
    require "$PlugIn";
    select STDOUT;
  } else {
    print "Content-type: text/html\n\n";
    $AppendToPI = 1;
  };
  if ($AppendToPI) {
    print "\n",'<HTML><BODY bgcolor="',"$BGColor",'">',"\n";
    $id = $rshId;
    $lpwd = $lrshPWD;
    if ($rshPWD) {
      $pwd = $rshPWD;
    } else {
      $pwd = $lpwd;
      $pwd =~ s/\+/ /g;
      $pwd =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;
    };
    unless ($OStype) {$OStype = &GetOStype;};
    &PrintForm;
  };

} else { # Otherwise, run WebRSH.

  unless ($OStype) {$OStype = &GetOStype || &WebrshDie("Can\'t find OS type");};

  require "$ProgDir\\lib\\cgi-lib.pl";

  # Reset some cgi-lib parameters
  $cgi_lib'maxdata =  1073741824;      # maximum bytes to accept via POST
  $cgi_lib'writefiles = $TempDir;      # temporary directory to which to write files
  $cgi_lib'bufsize  =  $BufSize;       # default buffer size when reading multipart

  unless ($ENV{'CONTENT_TYPE'} =~ m#^multipart/form-data#) {
    &ReadParse(*input);
  } else {
    &ReadParse(*input,*CFileName,*CContType,*TFileName);
    unless ($input{'com'} eq 'rshupload' && $TFileName{'upfile'}) {&WebrshDie;};
  };

  $pwd = $input{'pwd'};
  $com = $input{'com'};
  &GetInidat;
  $ENV{'DIRCMD'} = '';
  if ($pwd) {
    &ChangeDir($pwd) || &WebrshDie("Can\'t change working directory to: $pwd \: $!");
  } else {
    &ChangeDir($HomeDir);
  };
  $id = $input{'id'};
  $id =~ y/0-9//d;
  $id = "$id$counter";
  if ($com) {
    pipe(SHELLERR,ERRPIPE); select(ERRPIPE); $| = 1;
    open(STDERR,">&ERRPIPE"); close(ERRPIPE);
    select(STDERR); $| = 1; select(STDOUT); # $| = 1;
    &DoCom;
    close(STDERR); $err = '';
    while (read(SHELLERR,$buf,$BufSize)) {
      $err = join('',$err,$buf);
    };
    if ($err && $output eq 'ok') {
      $output = $err;
    } else {
      $output = join('',$err,$output);
    };
  };
  &GetPwd;
  &UpdInidat;
  &SendDone;
};

#################################################################################################
# Main subroutines:

sub GetInidat { # Gets the current $counter and file-manager information.

  open(INIDAT, "<$CfgDir\\rshinidat.txt");
  $counter = <INIDAT>; chop($counter);
  $counter = $counter+1;
  $clip = <INIDAT>;
  close(INIDAT);
}

sub DoCom { # Executes the command $com.

  $com =~ s/[\r\n]//;
  ($mcom, $pcom) = split(/\s+/,$com,2);
  if ($mcom eq 'cd') {
    if ($pcom) {
      if (&ChangeDir($pcom)) {$output = 'Directory had been changed';};
    } else {$output = `cd`;};
  } elsif ($mcom eq 'rshhome') {
    if (&ChangeDir($HomeDir)) {$output = 'Directory had been changed';};
  } elsif ($mcom eq 'rshps') {
    require "$ProgDir\\lib\\$PsLib";
    $output = &RshPs;
  } elsif ($mcom eq 'rshkill') {
    require "$ProgDir\\lib\\$PsLib";
    $output = &RshKill($pcom);
  } elsif ($mcom eq 'rshlaunchlist' || $mcom eq 'rshexeclist' || $mcom eq 'rshgetlist') {
    require "$ProgDir\\lib\\listlib.pl";
    if ($pcom) {&ChangeDir($pcom);};
    unless ($!) {$output = 'ok';};
  } elsif ($mcom eq 'rshkilllist') {
    require "$ProgDir\\lib\\$PsLib";
    &GetKillList;
    unless ($!) {$output = 'ok';};
  } elsif ($mcom eq 'rshgethtm') {
    $output = &GetHTM($pcom);
  } elsif ($mcom eq 'rshget') {
    &SendFile($pcom);
    $done = 1;
  } elsif ($mcom eq 'rshgettxt') {
    &SendTextFile($pcom);
    $done = 1;
  } elsif ($mcom eq 'rshgetbin') {
    &SendBinFile($pcom);
    $done = 1;
  } elsif ($mcom eq 'rshtextmode') {
    &TextMode($pcom);
    $done = 1;
  } elsif ($mcom eq 'rshuploadform') {
    require "$ProgDir\\lib\\upldlib.pl";
    if ($pcom) {&ChangeDir($pcom);};
    unless ($!) {$output = 'ok';};
  } elsif ($mcom eq 'rshfm') {
    require "$ProgDir\\lib\\fmlib.pl"; 
    if ($pcom) {&ChangeDir($pcom);};
    &DoFMCom;
  } elsif ($mcom eq 'rshupload') {
    require "$ProgDir\\lib\\upldlib.pl"; 
    &DoUpload;
  } elsif ($mcom eq 'rshstart') {
    &RshStart($pcom);
  } elsif ($mcom eq 'rshperl') {
    $output = eval ($pcom);
  } elsif ($mcom =~ /^[A-Z].*/) {
    close(STDERR);
    open (PIPE, "$com|");
    close (PIPE);
  } elsif ($mcom eq 'rshoptions') {
    require "$ProgDir\\lib\\oplib.pl";
    &DoOpCom($input{'opt'},$input{'opcom'});
  } elsif ($mcom eq 'rshedit') {
    require "$ProgDir\\lib\\edlib.pl";
    &DoEditCom($pcom,'');
  } else {
    $output = `$com`;
  };
}

sub AllowAddr { # Determines whether an IP address is allowed access to WebRSH, based on
                # the @AllowAddr and @DenyAddr arrays.

  local($addr) = @_;
  local($allow,$i,$mask) = (0,0,'');
  if ($addr) {
    while (!$allow && $i <= $#AllowAddr) {
#      $mask = $AllowAddr[$i];
#      $mask =~ s/\./\\\./g;
#      $mask =~ s/\*/\\d\*/g;
      if ($addr =~ m/$AllowAddr[$i]/) {$allow = 1;};
      $i++;
    };
    if ($allow) {
      $i = 0;
      while ($allow && $i <= $#DenyAddr) {
#        $mask = $DenyAddr[$i];
#        $mask =~ s/\./\\\./g;
#        $mask =~ s/\*/\\d\*/g;
        if ($addr =~ m/$DenyAddr[$i]/) {$allow = 0;};
        $i++;
      };
    };
  };
  return $allow;
}

sub ConfirmUser { # Confirms that the accessing user is included in the @AllowUsers array.

  local($confirm,$i,$user) = (0,0,'');
  unless ($ENV{'SERVER_SOFTWARE'} =~ m/^WebSite/) {
    $user = $ENV{'REMOTE_USER'};
  } else {
    $user = $ENV{'AUTH_USER'};
  };
  while (!$confirm && $i <= $#AllowUsers) {
    $confirm = ($user eq $AllowUsers[$i]);
    $i++;
  };
  return $confirm;
}

sub WebrshDie { # Sends an error message and terminates execution of WebRSH.

  local(@msg) = @_;
  local($i);
  unless (@msg) {@msg = "WebRSH encountered a fatal error\n"};
  print "Content-type: text/html\n\n";
  print '<HTML><HEAD><TITLE> Execution Aborted </TITLE></HEAD><BODY><H2>',"\n",
  "$msg[0]",'</H2>',"\n";
  foreach $i (1 .. $#msg) {print '<P>',"$msg[$i]",'</P>',"\n";};
  print '<HR></BODY></HTML>',"\n";
  die @msg;
}

sub GetOStype { # Finds the operating system in use.

  local(@osinfo) = Win32::GetOSVersion;
  if ($osinfo[4] eq '2') {return 'wNT';}
    elsif ($osinfo[4] eq '1') {return 'w95';}
    else {return 0;};
}

sub GetPwd { # Updates $pwd and $lpwd to hold the current working directory.

#  $pwd = `cd`; chop($pwd);
  $pwd = Win32::GetCwd;
  $lpwd = &UrlEncode($pwd);
}

sub UpdInidat { # Updates rshinidat.txt.

  open (INIDAT, ">$CfgDir\\rshinidat.txt");
  print INIDAT "$counter\n$clip";
  close (INIDAT);
}

sub SendDone { # Prints WebRSH's html output

  unless ($done) {
    print "Content-type: text/html\n\n";
    if ($com) {
      if ($mcom eq 'rshlaunchlist') {&PrintLaunch;}
      elsif ($mcom eq 'rshkilllist') {&PrintKill;}
      elsif ($mcom eq 'rshexeclist') {&PrintExec;}
      elsif ($mcom eq 'rshgetlist') {&PrintGet;}
      elsif ($mcom eq 'rshuploadform') {&PrintUpload;}
      elsif ($mcom eq 'rshgethtm') {&PrintHTM;}
      elsif ($mcom eq 'rshfm') {&PrintFM;}
      elsif ($mcom eq 'rshoptions') {&PrintOptions;}
      elsif ($mcom eq 'rshedit') {&PrintEdit;}
      else {&PrintCom;};
    } else {&PrintNull;};
    &PrintForm;
  }
}

#################################################################################################
# Secondary subroutines ("utilities"):

sub ExSysCom { # Executes a system (shell) command, and returns its output.

  local($syscom) = @_;
  if ($OStype eq 'w95') {$syscom =~ s/\%/\%\%/g;};
  return `$syscom`;
}

sub ChangeDir { # Changes the working directory (It is used instead of "chdir" to overcome a bug
                # in some builds of Perl for Win32).

  local($dir) = @_;
  if ($dir =~ m/^[\\\/]/) {
    &WebrshDie("$dir is not a valid directory\!");
  } else {
    $dir = "$dir\\" if ($dir =~ m/^\w\:$/);
    chdir $dir;
  };
}

sub HtmlText { # Converts plain text to a format suitable for embedding in HTML.

  local($text) = @_;
  $text =~ s/\&/\&amp\;/g;
  $text =~ s/\</\&lt\;/g;
  $text =~ s/\>/\&gt\;/g;
  $text =~ s/\"/\&quot\;/g;
  return $text;
}

sub UrlChar { # Url-encodes a character (assumes characters above 0F).

  local($char) = @_;
  $char = join('','%',sprintf("%lx",unpack("c",$char)));
  $char =~ y/a-z/A-Z/;
  return $char;
}

sub UrlEncode { # Returns a url-encoded string (does not encode 00-0F control characters).

  local($string) = @_;
  $string =~ s/\%/\%25/g;
  $string =~ s/\+/\%2B/g;
  $string =~ s/ /\+/g;
  $string =~ s/[^\x00-\x0f\!\"\$\%\'\(\)\*\+\-\.\w]/&UrlChar($&)/ge;
  return $string;
}

sub ExistFile { # Checks if a file or a directory exists without generating an error in case
                # it does not.

  local($filename) = @_;
  $ErrorHolder = $!;
  local($exists) = -e $filename;
  $! = $ErrorHolder; ``;
  return $exists;
}

sub FullPath { # Returns the full path name for a file in a directory.

  local($directory,$file) = @_;
  local($path);
  if ($directory =~ m/\\$/) {
    $path = "$directory$file";
  } else {$path = "$directory\\$file";};
  return $path;
}

sub FileName { # Extracts the name of the file from its full path name.

  local($name) = @_;
  $name =~ s/\\/\//g; 
  $name =~ s/(\W)/\\$1/g;
  $name =~ m/([^\/]+)$/;
  $name = $1;
  $name =~ s/\\//g;
  return $name;
}

sub DirName { # Extracts the name of the directory from the full path name of a file.

  local($name) = @_;
  $name =~ s/\\/\//g; 
  $name =~ s/(\W)/\\$1/g;
  $name =~ m/^(.+)\/([^\/]+)$/;
  $name = $1;
  $name =~ s/\\//g;
  $name =~ s/\//\\/g;
  return $name;
}

sub FileExt { # Returns the (capitalized) extension of a filename.

  local($filename) = @_;
  $filename =~ m/(\.[^\.]*$)/;
  local($ext) = $1;
  $ext =~ y/a-z/A-Z/;
  return $ext;
}
  
sub GetDirList { # Creates two arrays (a plain version and an url-encoded one) each of which   
                 # contains the list of directories in the current working directory. The 
                 # creation of the url-encoded array is suppressed if the function gets a
                 # true valued parameter.

  local($NoUrlEn) = @_;
  $dirlist = `dir /B /AD /ON`;
  chop $dirlist;
  @dirarray = split(/\n/,$dirlist);
  unless ($NoUrlEn) {
    $ldirlist = &UrlEncode($dirlist);
    @ldirarray = split(/\n/,$ldirlist);
  };
}

sub GetFileList { # Creates two arrays (a plain version and an url-encoded one) each of which   
                  # contains the list of files in the current working directory. The creation
                  # of the url-encoded array is suppressed if the function gets a true valued
                  # parameter.

  local($NoUrlEn) = @_;
  $filelist = `dir /B /A-D /ON`;
  chop $filelist;
  @filearray = split(/\n/,$filelist);
  unless ($NoUrlEn) {
    $lfilelist = &UrlEncode($filelist);
    @lfilearray = split(/\n/,$lfilelist);
  };
}

sub GetHTM { # Reads a text file and returns its content.

  local($htmfile) = @_;
  local($buf,$content) = ('','');
  open (HTM, "<$ProgDir\\htm\\$htmfile") || WebrshDie("Can\'t find $htmfile: $!");
  while (read(HTM,$buf,$BufSize)) {
    $content = join('',$content,$buf);
  };
  close HTM;
  return $content;
}

sub ContType { # Returns the MIME Content-type of a file based on its extension (according
               # to the correspondence set in the file Mimetable.txt).

  local($filename) = @_;
  local($ext,$cont,$fext,$fcont,$buf,*mtable);
  $fext = &FileExt($filename);
  open(MTABLE,"<$CfgDir\\Mimetable.txt") || &WebrshDie("Can\'t find MIME table: $!");
  while (read(MTABLE,$buf,$BufSize)) {
    $mtable = join('',$mtable,$buf);
  };
  close(MTABLE);
  @mtable = split(/\n/,$mtable);
  local($i) = 0;
  while (!$fcont && $i <= $#mtable) {
    ($ext,$cont) = split(/\s+/,$mtable[$i],2);
    if ($ext eq $fext) {$fcont = $cont;};
    $i++;
  };
  unless ($fcont) {$fcont = $DefMimeType;};
  return $fcont;
}

sub SendFile { # Sends a file to the client, reporting its approriate Content-type.

  local($filename) = @_;
  local($buf,$cont,$clh) = ('','','');
  open (FILE,"<$filename") || &WebrshDie("Can\'t find $filename: $!");
  $cont = &ContType($filename);
  if ($GCLH) {$clh = join('','Content-length: ',-s $filename,"\n");};
  print "Content-type: $cont\n$clh\n";  
  binmode FILE;
  while (read(FILE,$buf,$BufSize)) {print $buf;};
  close FILE;
}

sub SendTextFile { # Sends a file to the client (optionally in text mode), reporting its 
                   # Content-type as text/plain.

  local($filename) = @_;
  local($buf,$clh) = ('','');
  open (FILE,"<$filename") || &WebrshDie("Can\'t find $filename: $!");
  if ($BinText) {
    binmode FILE;
    if ($GCLH) {$clh = join('','Content-length: ',-s $filename,"\n");};
  };
  print "Content-type: text/plain\n$clh\n";
  while (read(FILE,$buf,$BufSize)) {print $buf;};
  close FILE;
}

sub SendBinFile { # Sends a file to the client, reporting its Content-type as
                  # application/octet-stream.

  local($filename) = @_;
  local($buf,$clh) = ('','');
  open (FILE,"<$filename") || &WebrshDie("Can\'t find $filename: $!");
  if ($GCLH) {$clh = join('','Content-length: ',-s $filename,"\n");};
  print "Content-type: application/octet-stream\n$clh\n";  
  binmode FILE;
  while (read(FILE,$buf,$BufSize)) {print $buf;};
  close FILE;
}

sub TextMode { # Executes a command and returns its output to the client as text/plain.

  local($tmcom) = @_;
  local($clh) = '';
  $output = `$tmcom`;
  if ($GCLH) {$clh = join('','Content-length: ',length($output),"\n");};  
  print "Content-type: text/plain\n$clh\n";  
  print $output;
}

sub RshStart { # Launches a file.

  local($file) = @_;
  unless ($file =~ m/^\"/ || $file =~ m/\//) {$file = "\"$file\"";};
  close(STDERR);
  if ($OStype eq 'wNT') {
    open(PIPE,"start \"RshStart\" $file|");
  } else {
    open(PIPE,"start $file|");
  };
  close(PIPE);
}

#################################################################################################
# Subroutines to print html output:

sub PrintNull { # Prints the response to null (no $com) request.

  print '<HTML><HEAD><TITLE> WebRSH </TITLE></HEAD><BODY bgcolor="',"$BGColor",'">',"\n",
  '<CENTER><H1> Welcome to WebRSH </H1>',"\n",
  '<H4> You can use this form to execute commands on ',"$HostName",'</H4></CENTER>',"\n";
}

sub PrintCom { # Prints WebRSH's main (default) response.

  print '<HTML><HEAD><TITLE> WebRSH - Execution Report </TITLE></HEAD>',"\n",
  '<BODY bgcolor="',"$BGColor",'"><B> WebRSH: Your command ',"\'$com\'\n",
  ' had been executed </B>',"\n";
  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  unless ($output) {print '<P> Your command did not generate any output </P>',"\n";}
  else {
    print '<P> Your command generated the following output: </P>',"\n",
    '<CENTER><HR></CENTER>',"\n";
    print '<PRE>',&HtmlText($output),"\n";
    print '</PRE>';
  }
}

sub PrintHTM { # Parses and prints WebRSH html pages.

  if (!$output || $!) {
    print '<HTML><HEAD><TITLE> WebRSH - HTM Problem </TITLE></HEAD>',"\n",
    '<BODY bgcolor="',"$BGColor",'"><B> WebRSH: HTM Problem: </B>',"\n";
    if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";}
    print '<P> Your command did not generate any output </P>',"\n";
  } else {
    $output =~ s/<\!\$BGColor\!>/$BGColor/g;
    $output =~ s/<\!\$ScriptUrl\!>/$ScriptUrl/g;
    $output =~ s/<\!\$SendFilesUrl\!>/$SendFilesUrl/g;
    $output =~ s/<\!\$counter\!>/$counter/g;
    $output =~ s/<\!\$id\!>/$id/g;
    $output =~ s/<\!\$lpwd\!>/$lpwd/g;
    print "$output\n";
  };
}

sub PrintForm { # Prints WebRSH's main form.

  print '<CENTER><HR SIZE=6>',"\n";
  unless ($id =~ m/m/) {
    print '<H3>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshgethtm+mainhelp.htm"> [HELP]</A>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshhome"> [HOME]</A>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshfm"> [FM]</A>',"\n",
#    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=dir+%2FA+%2FW"> [DIR]</A>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshps"> [PS]</A>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshkilllist"> [KILL]</A>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshlaunchlist"> [LAUNCH]</A>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshexeclist"> [EXECUTE]</A>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshgetlist"> [GET]</A>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshuploadform"> [UPLOAD]</A>',"\n";
    if ($OStype eq 'wNT') {print
      '<A HREF="',"$ScriptUrl",'?rshplugin+',"$id",'+',"$lpwd",'+%3A%3A+services.pl"> [SERVICES]</A>',"\n";
    };
    print '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshoptions"> [OPTIONS]</A>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshgethtm+more.htm"> [MORE]</A>',"\n",
    '</H3><HR>',"\n";
  };
  print '<FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'" NAME="WebRSHMain">',"\n",
  '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
  '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n";
  unless ($id =~ m/c/) {
    print '<B> Working Directory is: ',"$pwd\n",'</B><BR><BR>',"\n",
    'COMMAND: <INPUT NAME="com"  SIZE="',"$ComFieldSize",'"><BR><BR>',"\n",
    '<INPUT VALUE="       Execute       "  TYPE=submit>',"\n",
    '<INPUT VALUE=" Clear " TYPE=reset><BR><BR><HR>',"\n";
  };
  print '</FORM></CENTER>';
  unless ($id =~ m/v/) {print "\n$VerInf\n";};
  print '</BODY></HTML>',"\n";
}

# The following lines exist only to avoid warning messages

$SendFilesDir       =  $SendFilesDir;
$SendFilesUrl       =  $SendFilesUrl;
$MakeBack           =  $MakeBack;
$GetOptions         =  $GetOptions;
$FMSize             =  $FMSize;
$EdCols             =  $EdCols;
$EdRows             =  $EdRows;
$EdWrap             =  $EdWrap;
$EdEmptyLnHldr      =  $EdEmptyLnHldr;
$EdTAMod            =  $EdTAMod;
$cgi_lib'writefiles =  $cgi_lib'writefiles;
$cgi_lib'bufsize    =  $cgi_lib'bufsize ;
$cgi_lib'maxdata    =  $cgi_lib'maxdata;
$CFileName          =  $CFileName;
$CContType          =  $CContType;
$filearray          =  $filearray;
$lfilearray         =  $lfilearray;
$dirarray           =  $dirarray;
$ldirarray          =  $ldirarray;

1; #return true 
